#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include <locale.h>

#define MAILSLOT_NAME	_T("\\\\.\\mailslot\\MimizunoQueueExe")
#define BUFFER_LENGTH	(10240)

int LaunchCommand(TCHAR *command, TCHAR *current, BOOL isWait) {
	TCHAR text[BUFFER_LENGTH];
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	CreateProcess(NULL, command, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS,
			NULL, current, &si, &pi);
	if (isWait) {
		WaitForSingleObject(pi.hProcess, INFINITE);
	}
	return 0;
}
int APIENTRY _tWinMain(HINSTANCE hInstance,
		HINSTANCE hPreInstance,
		LPTSTR lpCmdLine,
		int nCmdShow)
{
	TCHAR current[BUFFER_LENGTH];
	TCHAR command[BUFFER_LENGTH];
	HANDLE hMail, hFile;
	TCHAR text[BUFFER_LENGTH];
	DWORD dwWritten;
	int countDefault = 500,
		count = countDefault;
	DWORD sleepMilliseconds = 10;

	_tsetlocale(LC_ALL, _T(""));

	if (_tcscmp(lpCmdLine, _T(""))==0) {
		return 0;
	} else if (_tcscmp(lpCmdLine, _T("/server"))==0) {
		hMail = CreateMailslot(MAILSLOT_NAME, 0, 0, NULL);
		if (hMail != INVALID_HANDLE_VALUE) { //Server
			BOOL bResult;
			DWORD dwNextSize, dwCount, dwRead;
			while (1) {
				bResult = GetMailslotInfo(hMail, 0, &dwNextSize, &dwCount, NULL);
				if (!bResult) {
					break;
				}
				if (dwNextSize != MAILSLOT_NO_MESSAGE) {
					TCHAR *p;
					ReadFile(hMail, text, BUFFER_LENGTH, &dwRead, NULL);
					p = _tcstok(text, _T("\n"));
					_tcscpy(current, p);
					p = _tcstok(NULL, _T("\n"));
					_tcscpy(command, p);
					LaunchCommand(command, current, TRUE);
					count = countDefault;
				} else if (count-- <= 0) {
					break;
				}
				Sleep(sleepMilliseconds);
			}
		}
		return 0;
	}


	hFile = CreateFile(MAILSLOT_NAME, GENERIC_WRITE, FILE_SHARE_READ,
			NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {	//Launch server
		TCHAR module[BUFFER_LENGTH];
		PROCESS_INFORMATION pi;
		STARTUPINFO si;
		int retry = 10;
		ZeroMemory(&si, sizeof(si));
		si.cb = sizeof(si);
		GetModuleFileName(NULL, module, sizeof(module));
		_stprintf_s(text, BUFFER_LENGTH, _T("%s /server"), module);
		CreateProcess(NULL, text, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS,
				NULL, NULL, &si, &pi);
		do {
			Sleep(10);
			if (retry-- < 0) return 0;
			hFile = CreateFile(MAILSLOT_NAME, GENERIC_WRITE, FILE_SHARE_READ,
					NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		} while (hFile == INVALID_HANDLE_VALUE);
	}

	GetCurrentDirectory(BUFFER_LENGTH, current);
	_stprintf_s(text, BUFFER_LENGTH, _T("%s\n%s"), current, lpCmdLine);
	WriteFile(hFile, text, BUFFER_LENGTH, &dwWritten, NULL);
	CloseHandle(hFile);

	return 0;
}
